import { ExternalTokenizer, LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@codemirror/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const newline$1 = 26,
  newlineEmpty = 27,
  eof = 28;

const newline = 10, carriageReturn = 13, space = 32, tab = 9, hash = 35;

// Taken from https://github.com/lezer-parser/python/blob/main/src/tokens.js
const newlines = new ExternalTokenizer((input, stack) => {
  if (input.next < 0) {
    input.acceptToken(eof);
  } else if (input.next !== newline && input.next !== carriageReturn) ; else if (stack.context.depth < 0) ; else {
    input.advance();
    let spaces = 0;
    while (input.next === space || input.next === tab) { input.advance(); spaces++; }
    let empty = input.next === newline || input.next === carriageReturn || input.next === hash;
    input.acceptToken(empty ? newlineEmpty : newline$1, -spaces);
  }
}, {contextual: true, fallback: true});

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 13,
  states: "'tOnQXOOO!RQXO'#CaO!WQXO'#CaO!}QXO'#CqO#UQXO'#C_O#jQXO'#CoO$RQXO'#C{O$aQXO'#CqO!]QXO'#CqOOQW'#Ct'#CtQ$uQXOOQOQXOOO%SQXO,58{O%kQXO,58{O%pQXO,58yOOQW,59],59]O&eQXO,58yO#jQXO,59ZO&jQXO'#C_O&oQXO,59ZO&rQXO'#CnO#jQXO,59YOOQW,59g,59gO&wQXO,59]OOQW-E6r-E6rOOQW'#Ce'#CeOOQW'#Cd'#CdO&|QXO'#CdO'bQYO1G.gO%SQXO1G.gOOQW1G.e1G.eO'jQXO1G.eO(_QXO1G.uOOQW1G.u1G.uOOQW1G.t1G.tO(gQXO1G.wOOQW'#Cr'#CrO)XQXO,59OO%SQXO'#CsO)`QYO7+$ROOQW7+$R7+$RO)hQ[O7+$ROOQW7+$P7+$POOQW7+$a7+$aOOQW7+$c7+$cOOQW-E6p-E6pOOQW1G.j1G.jOOQW,59_,59_OOQW-E6q-E6qOOQW<<Gm<<GmO)pQ[O<<GmOOQWAN=XAN=X",
  stateData: ")z~OnOSPOSkOS~OUPO]WO^VOjWOqQO~OSSOVTOYROZRO[RO~P]OV[O~OU]O~Ol_OUeXYeXZeX[eX]eX^eXieXjeXqeX~Oa^O~P!]OUPOVaOY`OZ`O[`OqQO~OSSOUPOVTOYbOZbO[bOqQO~OdeOjfOlfOioX~OUPOYgOZgO[gOjgOqQO~OYWOZWO[WO~P]OUPOYiOZiO[iO]iO^kOqQO~OVmO~OUPOYnOZnO[nO]nOqQOdRaiRajRalRa`Ra~OaoO~Oa^O~O`qOdeO~O_sO~OUPOYiOZiO[iO]iOqQO~O`xOpvO~OUPOYzOZzO[zO]zOqQOdRiiRijRilRi`Ri~O`{OdeO~Ol|OUeiYeiZei[ei]ei^eiieijeiqei~O_!OO~P&|O`!ROpvO~OpvOr!RO~OpvOr!TO~O]~",
  goto: "#xpPPPqP}PP!m!vPPPPPPPPq#PP#Z#_#e#oPPPPPP#uQUOQcTQpaRreQROQWYQ`SUbTaeQgVYi[kmuvQn^RzoQl[QymR!PvUj[mvTtkuQUOSdTaRreTXOYQukR}uQwlS!Qw!SR!SyQYORhYRZO",
  nodeNames: "⚠ Comment Program Comparison NOT FunctionExpression Function ( FunctionParameter ParamType MetadataField String Number PlainText [ ] ) Comparator BinaryExpression ParenthesizedExpression BinaryToken TitleFormatting",
  maxTerm: 34,
  skippedNodes: [0,1],
  repeatNodeCount: 3,
  tokenData: "3T~RoX^#Spq#Srs#wtu'iuv(Zvw)gwx*}xy+gyz+lz|)g|}+y}!P)g!P!Q,^!Q![-t![!c)g!c!d._!d!p.{!p!q0i!q!r2]!r!}.{!}#O2y#P#Q3O#T#o)g#y#z#S$f$g#S#BY#BZ#S$IS$I_#S$I|$JO#S$JT$JU#S$KV$KW#S&FU&FV#S~#XYn~X^#Spq#S#y#z#S$f$g#S#BY#BZ#S$IS$I_#S$I|$JO#S$JT$JU#S$KV$KW#S&FU&FV#S~#|Rq~Ot$Vuv$tv~$V~$YTOr$Vrs$is#O$V#O#P$n#P~$V~$nOZ~~$qPO~$V~$w_Op$Vpq%vqr$Vrs$is!Q$V!Q![%v![!c$V!c!}%v!}#O$V#O#P$n#P#R$V#R#S%v#S#T$V#T#o%v#o~$V~%yaOp$Vpq%vqr$Vrs$isu$Vuv'Ov!Q$V!Q![%v![!c$V!c!}%v!}#O$V#O#P$n#P#R$V#R#S%v#S#T$V#T#o%v#o~$V~'RTOr$Vrs'bs#O$V#O#P$n#P~$V~'iOY~Z~~'lS!Q!['x!c!}'x#R#S'x#T#o'x~'}SU~!Q!['x!c!}'x#R#S'x#T#o'x~(`X]Ppq({uv)gvw)gz!Q)g!Q![)x![!c)g!c!})x#R#S({#T#o)x~)OUpq({uv)b!Q![({!c!}({#R#S({#T#o({~)gOY~P)lS]Puv)gvw)gz!})g#T#o)g~)}X]Ppq({uv*jvw)gz!Q)g!Q![)x![!c)g!c!})x#R#S({#T#o)x~*qSY~]Puv)gvw)gz!})g#T#o)g~+QTOw*}wx$ix#O*}#O#P+a#P~*}~+dPO~*}~+lOV~V+qP`Rrs+tS+yOrSV,QSpU]Puv)gvw)gz!})g#T#o)g~,cU]Puv)gvw)gz!P)g!P!Q,u!Q!})g#T#o)g~,|XP~]POY-iZu-iuv,uvw,uwz-iz!},u!}#T-i#T#o,u#o~-i~-nQP~OY-iZ~-i~-{U[~]Puv)gvw)gz!Q)g!Q![-t![!})g#T#o)g~.fVa~]Puv)gvw)gz!c)g!c!p.{!p!q/c!q!}.{#T#o)g~/STa~]Puv)gvw)gz!c)g!c!}.{#T#o)g~/jVa~]Puv)gvw)gz!c)g!c!f.{!f!g0P!g!}.{#T#o)g~0YTd~a~]Puv)gvw)gz!c)g!c!}.{#T#o)g~0pVa~]Puv)gvw)gz!c)g!c!q.{!q!r1V!r!}.{#T#o)g~1^Va~]Puv)gvw)gz!c)g!c!v.{!v!w1s!w!}.{#T#o)g~1|TS~a~]Puv)gvw)gz!c)g!c!}.{#T#o)g~2dVa~]Puv)gvw)gz!c)g!c!t.{!t!u0P!u!}.{#T#o)g~3OO^~~3TO_~",
  tokenizers: [0, 1, 2, newlines],
  topRules: {"Program":[0,2]},
  tokenPrec: 408
});

const Foobar2000QueryLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                ParenthesizedExpression: delimitedIndent({ closing: ")", align: false })
            }),
            foldNodeProp.add({
                ParenthesizedExpression: foldInside
            }),
            styleTags({
                MetadataField: tags.variableName,
                String: tags.string,
                Comparator: tags.compareOperator,
                BinaryToken: tags.operatorKeyword,
                Number: tags.number,
                Function: tags.function(tags.variableName),
                "( )": tags.paren,
                "[ ]": tags.squareBracket,
                "NOT": tags.operatorKeyword,
                Comment: tags.lineComment,
                PlainText: tags.string
            })
        ]
    }),
    languageData: {
        closeBrackets: {
            brackets: ['(', '[', '%', '"']
        },
        commentTokens: {
            line: '//'
        }
    }
});
function Foobar2000Query() {
    return new LanguageSupport(Foobar2000QueryLanguage);
}

export { Foobar2000Query, Foobar2000QueryLanguage };
